<?php

class plxornament extends plxPlugin {

       public function __construct($default_lang) {
           parent::__construct($default_lang);
		
		$this->addHook('AdminArticleContent', 'AdminArticleContent');
		$this->addHook('AdminArticleTop', 'AdminArticleTop');
		$this->addHook('AdminArticleFoot', 'AdminArticleFoot');
		$this->addHook('AdminArticlePreview', 'AdminArticlePreview');
		$this->addHook('plxAdminEditArticleXml', 'plxAdminEditArticleXml');
		$this->addHook('plxMotorParseArticle', 'plxMotorParseArticle');
		$this->addHook('plxShowLastArtList', 'plxShowLastArtList');
	}

       public function AdminArticleContent() {
           echo '<p id="p_ornament"><label for="id_ornament">'.$this->getLang('L_ORNAMENT_FIELD').'</label><img id="id_ornament-image" src="../../plugins/plxeditor/plxeditor/images/image.gif" alt="" title="'.$this->getLang('L_ORNAMENT_FIELD').'" onclick="editor_ornament.execCommand(\'image\')" height="20" width="20">';
		echo '&nbsp;<img id="id_ornament-html" src="../../plugins/plxeditor/plxeditor/images/html.gif" alt="" title="" onclick="editor_ornament.execCommand(\'html\')" height="20" width="20">';
		echo '&nbsp;<a id="toggler_ornament" href="javascript:void(0)" onclick="toggleDiv(\'toggle_ornament\', \'toggler_ornament\', \'afficher\',\'masquer\')">afficher</a></p><div id="toggle_ornament" style="display: none;"><?php plxUtils::printArea("ornament",plxUtils::strCheck($ornament),"35","1","",""); ?></div>';
		echo '<p>&nbsp;</p>';
       }

	
	
	public function AdminArticlePreview()
	{
		echo "<?php \$art['ornament'] = \$_POST['ornament'];?>";
		
	}
	
	public function AdminArticleTop() {
	echo "<?php
			if(!empty(\$_POST) && \$_POST['ornament'] != '<br />') {
				\$ornament = trim(\$_POST['ornament']);
               if(!empty(\$_POST['preview'])) {
				\$art['ornament'] = trim(\$_POST['ornament']);}
               } elseif(!empty(\$_GET['a'])) {
				\$ornament =  trim(\$result['ornament']);
               } else {
				\$ornament='';
               }
		?>";
       }		

	public function plxAdminEditArticleXml() {
		echo "<?php    \$xml .= \"\t\".'<ornament><![CDATA['.plxUtils::cdataCheck(trim(\$content['ornament'])).']]></ornament>'.\"\n\"; ?>";
       }			
	
	public function plxMotorParseArticle() {
		echo "<?php    \$art['ornament'] = trim(\$values[ \$iTags['ornament'][0] ]['value']); ?>";
	}
	
	public function AdminArticleFoot()
	{
		//Penser à ajouter ligne 13 du fichier medias.php de plxeditor, 
		//l'id du champ ornament dans le tableau des id autorisés
		echo '
		<script type="text/javascript">
			<!--
				editor_ornament = new PLUXML.editor.create(\'editor_ornament\', \'id_ornament\', \'data/images/\',\'data/documents/\');
				$(\'#id_ornament-toolbars\').hide();
			-->
		</script>
		';
	}
	
	public function plxShowLastArtList(){
	$string =<<<END
<?php
		# Génération de notre motif
		if(empty(\$cat_id))
			\$motif = '/^[0-9]{4}.[home|'.\$this->plxMotor->activeCats.']*.[0-9]{3}.[0-9]{12}.[a-z0-9-]+.xml$/';
		else
			\$motif = '/^[0-9]{4}.[home|'.\$this->plxMotor->activeCats.']*'.str_pad(\$cat_id,3,'0',STR_PAD_LEFT).'['.\$this->plxMotor->activeCats.']*.[0-9]{3}.[0-9]{12}.[a-z0-9-]+.xml$/';

		# Nouvel objet plxGlob et récupération des fichiers
		\$plxGlob_arts = clone \$this->plxMotor->plxGlob_arts;
		if(\$aFiles = \$plxGlob_arts->query(\$motif,'art','.$order.',0,\$max,'before')) {
			foreach(\$aFiles as \$v) { # On parcourt tous les fichiers
				\$art = \$this->plxMotor->parseArticle(PLX_ROOT.\$this->plxMotor->aConf['racine_articles'].\$v);
				\$num = intval(\$art['numero']);
				\$date = \$art['date'];
				if((\$this->plxMotor->mode == 'article') AND (\$art['numero'] == \$this->plxMotor->cible))
					\$status = 'active';
				else
					\$status = 'noactive';
				# Mise en forme de la liste des catégories
				\$catList = array();
				\$catIds = explode(',', \$art['categorie']);
				foreach (\$catIds as \$idx => \$catId) {
					if(isset(\$this->plxMotor->aCats[\$catId])) { # La catégorie existe
						\$catName = plxUtils::strCheck(\$this->plxMotor->aCats[\$catId]['name']);
						\$catUrl = \$this->plxMotor->aCats[\$catId]['url'];
						\$catList[] = '<a title="'.\$catName.'" href="'.\$this->plxMotor->urlRewrite('?categorie'.intval(\$catId).'/'.\$catUrl).'">'.\$catName.'</a>';
					} else {
						\$catList[] = L_UNCLASSIFIED;
					}
				}
				# On modifie nos motifs
				\$row = str_replace('#art_id',\$num,\$format);
				\$row = str_replace('#cat_list', implode(', ',\$catList), \$row);
				\$row = str_replace('#art_url',\$this->plxMotor->urlRewrite('?article'.\$num.'/'.\$art['url']),\$row);
				\$row = str_replace('#art_status',\$status,\$row);
				\$row = str_replace('#art_author',plxUtils::strCheck(\$this->plxMotor->aUsers[\$art['author']]['name']),\$row);
				\$row = str_replace('#art_title',plxUtils::strCheck(\$art['title']),\$row);
				\$row = str_replace('#art_chapo',\$art['chapo'],\$row);
				\$strlength = preg_match('/#art_content\(([0-9]+)\)/',\$row,\$capture) ? \$capture[1] : '100';
				\$content = plxUtils::truncate(\$art['content'],\$strlength,\$ending,true,true);
				\$row = str_replace('#art_content('.\$strlength.')','#art_content', \$row);
				\$row = str_replace('#art_content',\$content, \$row);
				\$row = str_replace('#art_date',plxDate::formatDate(\$date,'#num_day/#num_month/#num_year(4)'),\$row);
				\$row = str_replace('#art_hour',plxDate::formatDate(\$date,'#hour:#minute'),\$row);
				\$row = str_replace('#art_nbcoms',\$art['nb_com'], \$row);
				if (!empty(\$art['ornament'])) {
					\$ornament = explode('src="',\$art['ornament']);
					\$ornament = substr(\$ornament[1],0,strpos(\$ornament[1],'"'));
					\$row = str_replace('#art_ornament','<img src="'.\$ornament.'" class="img-art-aside" alt="'.plxUtils::strCheck(\$art['title']).'"/>', \$row);
				} else {
					\$row = str_replace('#art_ornament','',\$row);
				}
				# On genère notre ligne
				echo \$row;
			}
		}
				return true;
?>
END;
	echo $string;
	}
   
}
?>